/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

jsLoader.loadSubScript("chrome://opensi/content/libs/query.js");

/**
 * @classDescription    Une classe reprsentant une rsolution
 * @constructor
 * @return {Object} un objet Resolution initialis  vide
 */
function Resolution () {}

Resolution.prototype = {
    Id_Resolution: 0,
    Id_Statut: 0,
    Id_Priorite: 0,
    Id_Evenement: 0,
    Util_R: 0,
    Description_Resolution: "",
    Date_Evenement: 0,
    Mode: "N",
    Id_Communication: 0,
    
    selectionner: function() {
        var req_resolution = new QueryHttp("CRM/Communications/selectionnerResolution.tmpl");
        req_resolution.setParam("Id_Resolution", this.Id_Resolution);
        var req = req_resolution.execute();
        return req;
    },
    
    supprimer: function() {
        var req_suppression = new QueryHttp("CRM/Communications/supprimerResolution.tmpl");
        req_suppression.setParam("Id_Resolution", this.Id_Resolution);
        var req = req_suppression.execute();
        return req;
    },
    
    enregistrer: function() {
        var req_enregistrement = new QueryHttp("CRM/Communications/enregistrerResolution.tmpl");
        req_enregistrement.setParam("Id_Resolution", this.Id_Resolution);
        req_enregistrement.setParam("Id_Communication", this.Id_Communication);
        req_enregistrement.setParam("Mode", this.Mode);
        req_enregistrement.setParam("Id_Statut", this.Id_Statut);
        req_enregistrement.setParam("Id_Priorite", this.Id_Priorite);
        req_enregistrement.setParam("Id_Evenement", this.Id_Evenement);
        req_enregistrement.setParam("Util_R", this.Util_R);
        req_enregistrement.setParam("Description_Resolution", this.Description_Resolution);
        req_enregistrement.setParam("Date_Evenement",
                                    (this.Date_Evenement == 0 || this.Date_Evenement == 1) ? 
                                    this.Date_Evenement :
                                    prepareDateHeureJava(this.Date_Evenement));
        var req = req_enregistrement.execute();
        return req;
    },
    
    setDefauts: function() {
        this.Id_Resolution = 0;
        this.Id_Statut = 0;
        this.Id_Priorite = 0;
        this.Id_Evenement = 0;
        this.Util_R = 0;
        this.Description_Resolution = "";
        this.Date_Evenement = 0;
        this.Id_Communication = 0;
        this.Mode = "N";
    },
    
    /**
     * Vrifier les paramtres
     * 
     * @exception {DateFormatException} si une date est invalide
     */
    verifier: function() {
        if (this.Date_Evenement != 0 && this.Date_Evenement != 1 && !isDateHeure(this.Date_Evenement))
            throw "DateFormatException";
    },
    
    aDateEvenement: function() {
        return (!(this.Id_Evenement == 0 || this.Id_Evenement == 1));
    }
}
