/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

// arbre de l'historique
var ga_communications = new Arbre("crm", "listeCommunicationsProspect.tmpl", "liste_communications_prospect");

/**
 * Initialisation de la fentre
 * 
 */
function init_historique_communications() {
    try {
        ga_communications.deleteTree();
        ga_communications.setParam("Id_Prospect", identifiant_prospect);
        ga_communications.initTree();
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#init_historique_communications : " + e);
    }
}

/**
 * Slectionner une rsolution dans l'arbre et dfinir la valeur de l'identifiant
 */
function selectionnerResolution() {
    try {
        document.getElementById("bModifierResolutionHistorique").disabled = false;
        document.getElementById("bSupprimerResolutionHistorique").disabled = false;
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#selectionnerResolution : " + e);
    }
}

/**
 * Modifier une rsolution slectionne
 */
function modifierResolutionHistorique() {
    try {
        selectionnerResolution();
        var tree = document.getElementById("liste_communications_prospect");
        var identifiant_resolution = getCellText(tree, tree.currentIndex, "IdResolution");
        var identifiant_communication = getCellText(tree, tree.currentIndex, "IdCommunication");
        document.getElementById("deck").selectedIndex = 2;
        // ouvre la communication en lecture
        init_resolution_communication(identifiant_resolution, identifiant_communication, "L");
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#modifierResolutionHistorique : " + e);
    }
}

/**
 * Supprimer une rsolution slectionne dans l'historique
 */
function supprimerResolutionHistorique() {
    try {
        var tree = document.getElementById("liste_communications_prospect");
        if (tree.view != null && tree.currentIndex != -1) {
            var id_reso = getCellText(tree, tree.currentIndex, "IdResolution");
            if (id_reso == 0) 
                showWarning("Pas de r\u00E9solution \u00E0 supprimer dans cette communication.")
            else {
                if (confirm("Supprimer cette r\u00E9solution ?")) {
                    var reso = new Resolution();
                    reso.Id_Resolution = id_reso;
                    var req = reso.supprimer();
                    if (req.responseXML.documentElement.getAttribute("code") == "succes") {
                        showMessage("R\u00E9solution supprim\u00E9e.");
                        identifiant_resolution = 0;
                        rafraichirHistoriqueCommunications();
                    } else 
                        showWarning("Echec de la suppression.");
                }
            }
        }
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#suprimerResolutionHistorique : " + e);
    }
}

/**
 * Modifier une communication
 */
function modifierCommunicationHistorique() {
    try {
        var tree = document.getElementById("liste_communications_prospect");
        if (tree.view != null && tree.currentIndex != -1) {
            var url = "chrome://opensi/content/crm/user/communications/resolution_communication.xul?" + cookie();
            url += "&Id_Prospect=" + identifiant_prospect;
            url += "&Id_Communication=" + getCellText(tree, tree.currentIndex, "IdCommunication");
            url += "&Mode=M";
            window.openDialog(url, "", "chrome, modal, centerscreen", rafraichirHistoriqueCommunications);
        }
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#nouvelleCommunicationHistorique : " + e);
    }
}

/**
 * Paramtrer une nouvelle communication
 */
function nouvelleCommunicationHistorique() {
    try {
        var url = "chrome://opensi/content/crm/user/communications/resolution_communication.xul?" + cookie();
        url += "&Id_Prospect=" + identifiant_prospect;
        window.openDialog(url, "", "chrome, modal, centerscreen", rafraichirHistoriqueCommunications);
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#nouvelleCommunicationHistorique : " + e);
    }
}

/**
 * Rafrachir la fentre de l'historique des communications
 */
function rafraichirHistoriqueCommunications() {
    try {
        ga_communications.deleteTree();
        ga_communications.setParam("Id_Prospect", identifiant_prospect);
        ga_communications.initTree();
        document.getElementById("bModifierResolutionHistorique").disabled = true;
        document.getElementById("bSupprimerResolutionHistorique").disabled = true;
    } catch (e) {
    	recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#rafraichirHistoriqueCommunications : " + e);
    }
}

/**
 * Rinitialise l'historique des communications  blanc
 */
function resetHistorique(){
    try {
        ga_communications.deleteTree();
    } catch (e) {
        recup_erreur("erreur dans crm/user/phoning/overlay_historique_communications_prospect.js#resetHistorique : " + e);
    }
}
