/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilit dportes      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

var ga_prospects = new Arbre("crm", "listeProspects.tmpl", "liste_prospects");

// critres de tri
var critere_etat;
var critere_valeur;
var critere_interet;
var critere_rs;

/**
 * Initialisation de fentre
 */
function init_tri() {
    try {
        load_rdf("liste_valeurs_prospect_tri", 
                 getUrlOpeneas("&Page=CRM/GetRDF/listeValeursProspect.tmpl&ContentType=xml"));
        fixerCriteresDefaut();
    } catch (e) {
	    recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#init_tri : "+ e);
    }
}

/**
 * Mettre les valeurs des critres aux valeurs par dfaut
 */
function fixerCriteresDefaut() {
    critere_etat = -1;
    critere_interet = -1;
    critere_valeur = -1;
    critere_rs = "";
}

/**
 * Selectionner un prospect dans la liste et dfinir la valeur de l'identifiant
 */
function selectionnerProspect() {
    try {
        var tree = document.getElementById("liste_prospects");
        if (tree.view != null && tree.currentIndex != -1) {
            document.getElementById("bModifierProspectTri").disabled = false;
            document.getElementById("bSupprimerProspectTri").disabled = false;
        }
    } catch (e) {
        recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#selectionnerProspect : "+ e);
    }
}

/**
 * Selectionner un tat dans la liste, et dfinir la valeur du critre
 */
function selectionnerEtat() {
    try {
        critere_etat = document.getElementById("etat").value;
    } catch (e) {
        recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#selectionnerEtat : "+ e);
    }
}

/**
 * Selectionner un intert dans la liste, et dfinir la valeur du critre
 */
function selectionnerInteret() {
    try {
        critere_interet = document.getElementById("interet").value;
    } catch (e) {
        recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#selectionnerInteret : "+ e);
    }
}

/**
 * Selectionner une valeur de prospect dans la liste, et dfinir la valeur du critre
 */
function selectionnerValeur() {
    try {
        critere_valeur = document.getElementById("liste_valeurs_prospect_tri").value;
    } catch (e) {
        recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#selectionnerValeur : "+ e);
    }
}

/**
 * Afficher une fiche prospect pour modification
 */
function modifierProspectTri() {
    try {
        var tree = document.getElementById("liste_prospects");
        if (tree.view != null && tree.currentIndex != -1) {
            document.getElementById("deck").selectedIndex = 1;
            document.getElementById("fiche_prospect").selectedIndex = 0;
            init_phoning(getCellText(tree, tree.currentIndex, "IdProspect"));
        }
    } catch (e) {
        recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#modifierProspectTri : "+ e);
    }
}

/**
 * Crer un nouveau prospect
 */
function nouveauProspectTri() {
    try {
        fixerCriteresDefaut();
        document.getElementById("deck").selectedIndex = 1;
        init_phoning();
    } catch (e) {
	    recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#nouveauProspectTri : "+ e);
    }
}

/**
 * rechercher des prospects suivant le paramtrage
 */
function rechercherProspectsTri(){
    try {
        ga_prospects.deleteTree();
        critere_rs = document.getElementById("txtRaisonSocialeTri").value;
	    ga_prospects.setParam("Etat", critere_etat);
	    ga_prospects.setParam("Interet", critere_interet);
	    ga_prospects.setParam("Id_Valeur_Prospect", critere_valeur);
	    ga_prospects.setParam("Raison_Sociale", critere_rs);
        ga_prospects.initTree();
    } catch (e) {
	    recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#rechercherProspectsTri : "+ e);
    }
}

/**
 * Supprimer un prospect slectionn
 */
function supprimerProspectTri() {
    try {
        var tree = document.getElementById("liste_prospects");
        if (tree.view != null && 
            tree.currentIndex != -1 &&
            confirm("Supprimer ce prospect ?")) {
                var prospect = new Prospect();
                prospect.Id_Prospect =  getCellText(tree, tree.currentIndex, "IdProspect");
                var req = prospect.supprimer();
                if (req.responseXML.documentElement.getAttribute("code") == "succes") {
                    showMessage("Prospect supprim\u00E9.");
                    rechercherProspectsTri();
                } else 
                    showWarning("Echec de la suppression.");
            } 
    } catch (e) {
	    recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#supprimerProspectTri : "+ e);
    }
}

function envoyerRSTri(ev) {
    try {
        if (ev.keyCode == 13) {
            fixerCriteresDefaut();
            rechercherProspectsTri();
        }
    } catch (e) {
	    recup_erreur("erreur dans crm/user/prospects/overlay_tri_prospects.js#envoyerRSTri : "+ e);
    }
}
