USE <base generale>;
ALTER TABLE UTILISATEUR_DOSSIER ADD COLUMN Acc_Crm TINYINT(3) UNSIGNED NOT NULL DEFAULT 0;
ALTER TABLE UTILISATEUR_DOSSIER ADD COLUMN Acc_Pdv TINYINT(3) UNSIGNED NOT NULL DEFAULT 0;

/* Uniquement pour l'utilisation de la fonction de mailing */
USE FACT_<DOSSIER>;
ALTER TABLE FACT_<DOSSIER>.FICHE_CLIENT ADD COLUMN Mailing TINYINT(3) UNSIGNED NOT NULL DEFAULT 1;

USE MYSQL;
CREATE DATABASE CRM_<dossier>;
USE CRM_<dossier>;

SET FOREIGN_KEY_CHECKS=0;

DROP TABLE IF EXISTS OPERATION;
DROP TABLE IF EXISTS OPERATION_PROSPECT;
DROP TABLE IF EXISTS VALEUR_PROSPECT;
DROP TABLE IF EXISTS PROSPECT;
DROP TABLE IF EXISTS EVENEMENT;
DROP TABLE IF EXISTS RESOLUTION_COMMUNICATION;
DROP TABLE IF EXISTS COMMUNICATION;
DROP TABLE IF EXISTS CANAL;
DROP TABLE IF EXISTS INITIATEUR;
DROP TABLE IF EXISTS RESOLUTION;
DROP TABLE IF EXISTS STATUT;
DROP TABLE IF EXISTS PRIORITE;

CREATE TABLE IF NOT EXISTS PROSPECT (
    Id_Prospect         VARCHAR(8) NOT NULL,                    -- identifiant du prospect
    Civilite            TINYINT UNSIGNED NOT NULL DEFAULT 0,    -- civilit
    Nom                 VARCHAR(30),                            -- nom du prospect
    Prenom              VARCHAR(50) NOT NULL DEFAULT '',        -- prnom du prospect
    Raison_Sociale      VARCHAR(100) NOT NULL DEFAULT '',       -- raison sociale de l'entreprise
    Adresse             VARCHAR(80),                            -- adresse de l'entreprise
    Comp_Adresse        VARCHAR(50) DEFAULT '',                 -- complment d'adresse
    Code_Postal         VARCHAR(10),                            -- code postal
    Ville               VARCHAR(50),                            -- ville
    Code_Pays           CHAR(2) DEFAULT 'FR',                   -- code pays
    Tel                 VARCHAR(20),                            -- tlphone fixe
    Mobile              VARCHAR(20),                            -- mobile
    Fax                 VARCHAR(20),                            -- numro de fax
    Email               VARCHAR(60),                            -- adresse courriel du propect
    Id_Valeur_Prospect  TINYINT(3),                             -- indice de valeur du prospect
    Site_Web            VARCHAR(80) DEFAULT '',                 -- url de l'entreprise
    Supprime            TINYINT UNSIGNED NOT NULL DEFAULT 0,    -- drapeau pour suppression virtuelle
    Divers              MEDIUMTEXT,                             -- renseignements divers
    Etat                TINYINT(3) UNSIGNED NOT NULL DEFAULT 0, -- drapeau de traitement du prospect
    Mailing             TINYINT(3) UNSIGNED NOT NULL DEFAULT 1, -- drapeau d'autorisation de mailing
    PRIMARY KEY(Id_Prospect)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS OPERATION (
    Id_Operation            TINYINT UNSIGNED NOT NULL AUTO_INCREMENT,   -- identifiant d'opration
    Intitule_Operation      VARCHAR(32) NOT NULL,                       -- intitul de l'opration
    PRIMARY KEY(Id_Operation)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS OPERATION_PROSPECT (
    Id_Operation        TINYINT UNSIGNED NOT NULL,            -- identifiant d'opration
    Id_Prospect         VARCHAR(8) NOT NULL,                  -- identifiant de prospect
    Util_Operation      int(10) unsigned not null,            -- identifiant de l'oprateur utilisateur    
    Date_Operation      BIGINT UNSIGNED NOT NULL DEFAULT 0,
    PRIMARY KEY(Id_Operation,Id_Prospect)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS VALEUR_PROSPECT (
    Id_Valeur_Prospect          TINYINT NOT NULL AUTO_INCREMENT,    -- identifiant
    Intitule_Valeur_Prospect    VARCHAR(32) NOT NULL,               -- intitul de valeur
    PRIMARY KEY(Id_Valeur_Prospect)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS CANAL (
    Id_Canal            TINYINT(3) NOT NULL AUTO_INCREMENT,    -- identifiant
    Intitule_Canal      VARCHAR(32) NOT NULL,                  -- intitul du canal de communication
    PRIMARY KEY (Id_Canal)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS INITIATEUR (
    Id_Initiateur       TINYINT(3) NOT NULL AUTO_INCREMENT,    -- identifiant
    Intitule_Initiateur VARCHAR(32) NOT NULL,                  -- intitul de l'initiateur de communication
    PRIMARY KEY (Id_Initiateur)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS COMMUNICATION (
    Id_Communication            INTEGER NOT NULL AUTO_INCREMENT,        -- identifiant
    Id_Prospect                 VARCHAR(8),                             -- identifiant de prospect
    Date_Communication          BIGINT NOT NULL DEFAULT 0,              -- date de la com en millisecondes
    Id_Initiateur               TINYINT(3) NOT NULL DEFAULT 1,          -- type d'initiateur, local ou tiers
    Id_Canal                    TINYINT(3) NOT NULL,                    -- identifiant de canal
    Util_C                      int(10) unsigned NOT NULL,             -- identifiant de l'utilisateur crateur de la communication
    Commentaire_Communication   TEXT DEFAULT '',                        -- descriptif de la communication        
    PRIMARY KEY (Id_Communication)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS STATUT (
    Id_Statut       TINYINT(3) NOT NULL AUTO_INCREMENT,    -- identifiant
    Intitule_Statut VARCHAR(32) NOT NULL,                  -- intitul du statut
    PRIMARY KEY (Id_Statut)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS PRIORITE (
    Id_Priorite         TINYINT(3) NOT NULL AUTO_INCREMENT,    -- identifiant
    Intitule_Priorite   VARCHAR(32) NOT NULL,                  -- intitul de la priorit
    PRIMARY KEY (Id_Priorite)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS EVENEMENT (
    Id_Evenement    TINYINT(3) NOT NULL AUTO_INCREMENT,     -- identifiant
    Type_Evenement  VARCHAR(32) NOT NULL,                   -- type de l'vnement
    PRIMARY KEY (Id_Evenement)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS RESOLUTION (
    Id_Resolution           INTEGER NOT NULL AUTO_INCREMENT,    -- identifiant
    Description_Resolution  TEXT NOT NULL DEFAULT '',           -- descriptif
    Id_Evenement            TINYINT(3) NOT NULL DEFAULT 0,      -- identifiant de l'vnement associ
    Id_Statut               TINYINT(3) NOT NULL,                -- identifiant de statut
    Id_Priorite             TINYINT(3) NOT NULL,                -- identifiant de priorit
    Util_R                  int(10) unsigned NOT NULL,          -- identifiant du responsable
    Date_Evenement          BIGINT UNSIGNED NOT NULL DEFAULT 0, -- date prvue de l'vnement
    Date_Maj_Resolution     BIGINT UNSIGNED NOT NULL DEFAULT 0, -- date de mise  jour
    Util_M                  int(10) unsigned NOT NULL,          -- identifiant de l'utilisateur qui a mis  jour la rsolution
    PRIMARY KEY (Id_Resolution)
) type=InnoDB;

CREATE TABLE IF NOT EXISTS RESOLUTION_COMMUNICATION (
    Id_Communication    INTEGER NOT NULL,       -- identifiant de communication
    Id_Resolution       INTEGER NOT NULL,       -- identifiant de rsolution
    PRIMARY KEY (Id_Communication, Id_Resolution)
) type=InnoDB;

INSERT INTO OPERATION (Intitule_Operation) VALUES ('Creation'), ('Maj');
INSERT INTO VALEUR_PROSPECT (Intitule_Valeur_Prospect) VALUES ('Lead'), ('Prospect'), ('Hot prospect');
INSERT INTO CANAL (Intitule_Canal) VALUES ('Tlphone'), ('Fax'), ('Courriel'), ('Parole');
INSERT INTO INITIATEUR (Intitule_Initiateur) VALUES ('Tiers'), ('Local');
INSERT INTO EVENEMENT (Type_Evenement) VALUES ('A rappeler'), ('Rendez-vous'), ('A recontacter'), ('Envoyer plaquette');
INSERT INTO STATUT (Intitule_Statut) VALUES ('Nouveau'), ('En cours'), ('Termin');
INSERT INTO PRIORITE (Intitule_Priorite) VALUES ('Faible'), ('Normale'), ('Moyenne'), ('Eleve');

ALTER TABLE PROSPECT ADD INDEX(Raison_Sociale);

ALTER TABLE PROSPECT ADD CONSTRAINT CT_FK_PROSPECT_ID_VALEUR_PROSPECT 
    FOREIGN KEY (Id_Valeur_Prospect) REFERENCES VALEUR_PROSPECT (Id_Valeur_Prospect);

ALTER TABLE OPERATION_PROSPECT ADD CONSTRAINT CT_FK_OPERATION_PROSPECT_ID_PROSPECT
    FOREIGN KEY (Id_Prospect) REFERENCES PROSPECT (Id_Prospect);
    
ALTER TABLE OPERATION_PROSPECT ADD CONSTRAINT CT_FK_OPERATION_PROSPECT_ID_OPERATION
    FOREIGN KEY (Id_Operation) REFERENCES OPERATION (Id_Operation);
    
ALTER TABLE COMMUNICATION ADD CONSTRAINT CT_FK_COMMUNICATION_ID_INITIATEUR
    FOREIGN KEY (Id_Initiateur) REFERENCES INITIATEUR (Id_Initiateur);
    
ALTER TABLE COMMUNICATION ADD CONSTRAINT CT_FK_COMMUNICATION_ID_CANAL
    FOREIGN KEY (Id_Canal) REFERENCES CANAL (Id_Canal);

ALTER TABLE COMMUNICATION ADD CONSTRAINT CT_FK_COMMUNICATION_ID_PROSPECT
    FOREIGN KEY (Id_Prospect) REFERENCES PROSPECT (Id_Prospect);
    
ALTER TABLE RESOLUTION ADD CONSTRAINT CT_FK_RESOLUTION_ID_STATUT
    FOREIGN KEY (Id_Statut) REFERENCES STATUT (Id_Statut);    
    
ALTER TABLE RESOLUTION ADD CONSTRAINT CT_FK_RESOLUTION_ID_PRIORITE
    FOREIGN KEY (Id_Priorite) REFERENCES PRIORITE (Id_Priorite);
    
ALTER TABLE RESOLUTION_COMMUNICATION ADD CONSTRAINT CT_FK_RESOLUTION_COMMUNICATION_ID_COMMUNICATION
    FOREIGN KEY (Id_Communication) REFERENCES COMMUNICATION (Id_Communication); 
     
ALTER TABLE RESOLUTION_COMMUNICATION ADD CONSTRAINT CT_FK_RESOLUTION_COMMUNICATION_ID_RESOLUTION
    FOREIGN KEY (Id_Resolution) REFERENCES RESOLUTION (Id_Resolution); 

SET FOREIGN_KEY_CHECKS=1;
