/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

/**
 * Génération d'une fiche prospect en pdf
 */

package com.ael.crm.actions.documents;


import org.experlog.openeas.api.ServletRequest;
import org.experlog.openeas.api.Action;
import org.experlog.openeas.api.Session;

import org.opensi.util.pdf.GlobalDocument;

import com.ael.crm.actions.documents.modeles.FicheProspectStd;
import com.ael.crm.actions.documents.modeles.DataProspect;


public class GenFicheProspect extends Action {


  public boolean serverSide() { return true; }

  public boolean service(Session s, ServletRequest r, Object info) throws Exception {
	
		String fichierPdf = "prospect_"+ r.getParameter("Id_Prospect") + "_" + r.getParameter("Id_Document") + ".pdf";
		
		String repPdf = s.getAppConfiguration().get("opensi.absdir") +"/pdf/";
		String repTemp = repPdf;
		
		GlobalDocument gd = new GlobalDocument(repPdf, fichierPdf);
		
		FicheProspectStd fiche = new FicheProspectStd(repTemp, new DataProspect(s, r.getParameter("Id_Prospect")));
	
		gd.addInternal(fiche);		
		
		gd.close(GlobalDocument.ON_EXIT);
	
		return true;
		
	}

}
