/******************************************************************************/
/* AEL Sarl : Web hosting, datacenter, gestion et comptabilité déportées      */
/* Copyright (C) 2008 Affaires En Ligne S.A.R.L.                              */
/* Contact : contact@affaires-en-ligne.fr                                     */
/* Web : http://www.spidboutic.fr                                             */
/*                                                                            */
/* This program is free software; you can redistribute it and/or              */
/* modify it under the terms of the GNU General Public License                */
/* as published by the Free Software Foundation; either version 2             */
/* of the License, or (at your option) any later version.                     */
/*                                                                            */
/* This program is distributed in the hope that it will be useful,            */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the               */
/* GNU General Public License for more details.                               */
/*                                                                            */
/* You should have received a copy of the GNU General Public License          */
/* along with this program; if not, write to the Free Software                */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. */
/******************************************************************************/

package com.ael.crm.metier;

import java.util.Comparator;

/**
 * Class fabrique pour obtenir un comparateur de Prospects
 * @author jm
 */
public class FabriqueComparateurProspect {
	
	public static Comparator<Prospect> getComparateurProspect(String cle) throws ClassNotFoundException {
		if (cle.equals("recontact"))
			return new ComparateurARecontacter();
		else if (cle.equals("rdv"))
			return new ComparateurRendezVous();
		else if (cle.equals("raison_sociale"))
			return new ComparateurRaisonSociale();
		else
			throw new ClassNotFoundException("clé de fabrique inconnue");
	}
}
